#
# Solution to July/August Actuarial Review Puzzle - Glenn Meyers
#
# Problem 1
#
f1=function(a){
  y=(a*cosh(sqrt(8)/a)-a+1-2)^2
  return(y)
}
a=optimize(f1,interval=c(1,9))
a1=a$minimum
print(a$objective) # should be close to zero
len1=function(x){
  f=sqrt(1+sinh(x/a1)^2)
  return(f)
}
llim1=0
ulim1=llim1+sqrt(8)
length1=integrate(len1,llim1,ulim1)
print(c(a1,length1$value,round(100*length1$value/sqrt(8)-100,2)))
x=llim1+(0:100)*(ulim1-llim1)/100
y=a1*cosh(x/a1)-a1+1
par(mfrow=c(2,1))
plot(x,y,type="l",lwd=3,ylim=c(0,2),ylab="Heigth",main="Problem 1",
sub=
  paste("Increase in Rope Length =",round(100*length1$value/sqrt(8)-100,2),"%"))
abline(1,0,lwd=1)
abline(2,0,lwd=1)
abline(line(c(0,sqrt(8)),c(1,2)),lwd=3)
#
# Problem 2
#
f2=function(La){
  L=La[1]
  a=La[2]
  y=(a*cosh((sqrt(8)-L)/a)-a-2)^2+(a*cosh(-L/a)-a-1)^2
  return(y)
}
La2=optim(c(.5,1),f2)
print(La2$value) #should be close to zero
L2=La2$par[1]
a2=La2$par[2]
len2=function(x){
  f=sqrt(1+sinh(x/a2)^2)
  return(f)
}
llim2=-L2
ulim2=sqrt(8)-L2
length2=integrate(len2,llim2,ulim2)
print(c(L2,a2,length2$value,round(100*length2$value/sqrt(8)-100,2)))
x=llim2+(0:100)*(ulim2-llim2)/100
y=a2*cosh(x/a2)-a2
plot(x,y,type="l",lwd=3,ylim=c(0,2),ylab="Heigth",main="Problem 2",
  sub=
  paste("Increase in Rope Length =",round(100*length2$value/sqrt(8)-100,2),"%"))
abline(1,0,lwd=1)
abline(2,0,lwd=1)
abline(0,0,lwd=1)
abline(line(c(-L2,sqrt(8)-L2),c(1,2)),lwd=3)
